package de.accso.flexinale.data.model;

import de.accso.flexinale.shared_kernel.Identifiable;
import jakarta.persistence.EnumType;
import org.apache.commons.lang3.builder.EqualsBuilder;
import org.apache.commons.lang3.builder.HashCodeBuilder;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;

import java.io.Serializable;

@jakarta.persistence.Entity
public class Ticket implements Identifiable, Serializable {

    public enum VerkaufsKanal {
        ONLINE,
        ZENTRAL,
        KINOKASSE
    }

    @jakarta.persistence.Id
    public String id;  // primary key

    @jakarta.persistence.ManyToOne
    public Film film;

    @jakarta.persistence.ManyToOne
    public Vorfuehrung vorfuehrung;

    @jakarta.persistence.ManyToOne
    public Benutzer benutzer;

    @jakarta.persistence.Enumerated(EnumType.STRING)
    public VerkaufsKanal verkaufsKanal;

    protected Ticket() {
    }

    public Ticket(final String id, final Film film, final Vorfuehrung vorfuehrung, final Benutzer benutzer,
                  final VerkaufsKanal verkaufsKanal) {
        this.id = id;
        this.film = film;
        this.vorfuehrung = vorfuehrung;
        this.benutzer = benutzer;
        this.verkaufsKanal = verkaufsKanal;
    }

    @Override
    public Id id() {
        return Identifiable.Id.of(id);
    }

    @Override
    public String toString() {
        return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
    }

    @Override
    public boolean equals(final Object o) {
        if (this == o) {return true;}

        if (o == null || getClass() != o.getClass()) {return false;}

        Ticket that = (Ticket) o;

        return new EqualsBuilder().append(id, that.id).append(film, that.film)
                .append(vorfuehrung, that.vorfuehrung).append(benutzer, that.benutzer)
                .append(verkaufsKanal, that.verkaufsKanal)
                .isEquals();
    }

    @Override
    public int hashCode() {
        return new HashCodeBuilder(17, 37)
                .append(id).append(film).append(vorfuehrung).append(benutzer)
                .append(verkaufsKanal)
                .toHashCode();
    }
}
